using Indotalent.ConfigBackEnd.Interfaces;
using Indotalent.ConfigFrontEnd.Common;
using Indotalent.Features.Inventory.TransactionReport.Cqrs;
using Indotalent.Infrastructure.Authentication.Identity;
using Indotalent.Shared.Models;
using Microsoft.AspNetCore.Components;
using MudBlazor;
using RestSharp;

namespace Indotalent.Features.Inventory.TransactionReport;

public class TransactionReportService : BaseService
{
    private readonly RestClient _client;

    public TransactionReportService(
            IHttpClientFactory clientFactory,
            NavigationManager nav,
            ISnackbar snackbar,
            ICurrentUserService currentUserService,
            TokenProvider tokenProvider)
            : base(clientFactory, nav, snackbar, currentUserService, tokenProvider)
    {
        _client = new RestClient(nav.BaseUri);
    }

    public async Task<ApiResponse<List<GetInventoryTransactionReportListDto>>?> GetInventoryTransactionReportListAsync()
    {
        var request = new RestRequest("api/transaction-report", Method.Get);
        return await ExecuteWithResponseAsync<List<GetInventoryTransactionReportListDto>>(_client, request);
    }

    public async Task<ApiResponse<InventoryTransactionReportLookupResponse>?> GetInventoryTransactionReportLookupAsync()
    {
        var request = new RestRequest("api/transaction-report/lookup", Method.Get);
        return await ExecuteWithResponseAsync<InventoryTransactionReportLookupResponse>(_client, request);
    }
}